package com.fp.persistence.pgeneral.safe;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TSAFETERMINAL*/
@Embeddable
public class TsafeTerminalKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="TERMINALCODE", nullable=false,updatable=false)

/**
* Codigo de terminal
*/
private String terminalcode;

@Column(name="COMPANYCODE", nullable=false,updatable=false)

/**
* Codigo de compania al que pertenece la oficina
*/
private Integer companycode;

/**Contructor por defecto*/
public TsafeTerminalKey(){}
/**Contructor de TsafeTerminalKey
@param pTerminalcode Codigo de terminal
@param pCompanycode Codigo de compania al que pertenece la oficina
*/
public TsafeTerminalKey(String pTerminalcode,Integer pCompanycode){
 terminalcode=pTerminalcode;
 companycode=pCompanycode;
}
/**Obtiene el valor de terminalcode
@return valor de terminalcode*/
public String getTerminalcode(){
  return terminalcode;
}
/**Fija el valor de terminalcode
@param pTerminalcode nuevo Valor de terminalcode*/
public void setTerminalcode(String pTerminalcode){
  terminalcode=pTerminalcode;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Implementación de la comparación de TsafeTerminalKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TsafeTerminalKey))return false;
  TsafeTerminalKey that = (TsafeTerminalKey) o;
  if (this.getTerminalcode() == null || that.getTerminalcode() == null){
      return false;
  }
  if (! this.getTerminalcode().equals(that.getTerminalcode())){
    return false;
  }
  if (this.getCompanycode() == null || that.getCompanycode() == null){
      return false;
  }
  if (! this.getCompanycode().equals(that.getCompanycode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TsafeTerminalKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getTerminalcode() == null ? 0 : this.getTerminalcode().hashCode());
    result = result * 37 + (this.getCompanycode() == null ? 0 : this.getCompanycode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
